package background

import (
	"time"

	"git.fjla.uk/owlboard/timetable-mgr/cif"
	"git.fjla.uk/owlboard/timetable-mgr/corpus"
	"git.fjla.uk/owlboard/timetable-mgr/helpers"
	"git.fjla.uk/owlboard/timetable-mgr/log"
)

const frequency = 3 * time.Second // Figure out a sensible frequency!

func InitTicker(cfg *helpers.Configuration, stop <-chan struct{}) {
	go runTicker(cfg, stop)
}

func runTicker(cfg *helpers.Configuration, stop <-chan struct{}) {
	log.Msg.Sugar().Infof("Starting background ticker, runs every %s", frequency)
	ticker := time.NewTicker(frequency)
	defer ticker.Stop()

	for {
		select {
		case <-stop:
			return
		case <-ticker.C:
			go cif.CifCheck(cfg)
			go corpus.CheckCorpus(cfg)
		}
	}
}
